# Demonstrate a button with a custom click event
#

import pyglet


class MyButton(pyglet.event.EventDispatcher):

    def __init__(self, text, window, x, y):
        super(MyButton, self).__init__()
        self._label = pyglet.text.Label(text,
                x=x, y=y)
        window.push_handlers(self.on_mouse_press)

    def draw(self):
        self._label.draw()

    def click(self):
        self.dispatch_event('on_click')

    def on_mouse_press(self, x, y, button, modifiers):
        if x <= self._label.x or x >= self._label.content_width + self._label.x:
            return False
        if y <= self._label.y or y >= self._label.content_height + self._label.y:
            return False
        self.click()
        return True

    def on_click(self):
        print 'Click event called'

MyButton.register_event_type('on_click')


class MyWindow(pyglet.window.Window):

    def __init__(self):
        super(MyWindow, self).__init__()

        self._button = MyButton('Click me', self, 100, 100)
        
    def on_draw(self):
        self.clear()
        self._button.draw()


if __name__ == "__main__":
    win = MyWindow()
    pyglet.app.run()
